;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname 08-1-function-sum) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ())))
;; function-sum.rkt

(require rackunit)
(require "extras.rkt")

;; function-sum : 
;;   Nat Nat (Nat Nat -> Number) -> Number
;; GIVEN: natural numbers lo <= hi and a function f,
;; RETURNS: SUM{f(j) | lo <= j <= hi}

;; EXAMPLES/TESTS:
(begin-for-test
  (check-equal?
    (function-sum 1 3 (lambda (j) j))
    (+ 1 2 3))
  (check-equal?
    (function-sum 1 3 (lambda (j) (+ j 10)))
    (+ 11 12 13))
  (check-equal?
    (function-sum 1 3 sqr)
    (+ 1 4 9)))

;; before defining function-sum, we'll write the generalized version:

;; function-sum-generalized : 
;;   Nat Nat Number (Nat Nat -> Number) -> Number
;; GIVEN: natural numbers i <= hi , a number sofar, and a function f,
;; RETURNS: sofar + SUM{f(j) | i <= j <= hi} 

;; EXAMPLES/TESTS:
(begin-for-test
  (check-equal?
    (function-sum-generalized 1 3 17 (lambda (j) j))
    (+ 17 (+ 1 2 3)))
  (check-equal?
    (function-sum-generalized 1 3 42 (lambda (j) (+ j 10)))
    (+ 42 (+ 11 12 13))))

;; STRATEGY: General Recursion
;; HALTING MEASURE: (- hi i)

(define (function-sum-generalized i hi sofar f)
  (cond
    [(= i hi) (+ sofar (f i))]
    [else (function-sum-generalized
            (+ i 1)
            hi
            (+ sofar (f i))
            f)]))

;; now we can define function-sum:
;; STRATEGY: function composition
(define (function-sum lo hi f)
  (function-sum-generalized lo hi 0 f))
